unit MyDlgAl;

interface

uses
     Windows,
     Messages,
     Algor,
      MyFButt,
      MyConst,
      MyUtils,
      dbg,
     MyForms;


 const
      adlg_w : integer = 554;
      adlg_h : integer = 380;

      qd_count = 100;

      tab_count = 13;

type

     MyAlarmDlg = class(TLiteWindow)
     num        : dword;
//     obj        : MyEvent;
     qd         : array[0..qd_count] of MyQuad;
     tab_number : integer;
     offset     : byte;

     am_calendar : boolean;

     protected
      procedure    OnLstCol(var Msg:  TMessage); message    WM_CTLCOLORLISTBOX;
      procedure    OnStCol(var Msg:  TMessage); message     WM_CTLCOLORSTATIC;
      procedure    OnEditCol(var Msg:  TMessage); message   WM_CTLCOLOREDIT;
      procedure    OnClose(Var Msg: TMessage); message      WM_CLOSE;
      procedure    OnPaint(Var Msg: TMessage); message      WM_PAINT;
      procedure    OnCommand(Var Msg: TWMCommand); message  WM_COMMAND;
      procedure    OnLMouseUp(Var Msg: TMessage); message   WM_LBUTTONUP;
     private
      procedure    FullQuad;
     public
     hrecord,
     htype, hdescript, hlistwd, hmonlist, hkal, hact,
     hyear, htime,
     hper, hdel, hdiz, hrtm, hinf, hfil, hdisp, hcik,
     {hdr,} hdr10000, hdr1000, hdr100, hdr10, hdr1 : THandle;
     hi_knopki, hi_byear, hi_other, hi_l, hi_r, hi_gbar, hi_bart,
     hi_barb, hi_rsp, hi_bok, hi_badd, hi_bcancel, hi_bhelp, hi_bast
     : THandle;
     procedure full; override;
     procedure aftercreate; override;
     constructor Create(n : dword);
     procedure Close;
     procedure SetRemove(b : boolean);
     procedure SetDisable(b : boolean);
     procedure SetDisplay(b : boolean);
     procedure SetRealtime(b : boolean);
     procedure SetInfluence(b : boolean);
     procedure SetDisplayYear(w : word);
     procedure DisplayTime;
     procedure SetVisCtl(a : dword);
     procedure SetVisFil;
     procedure SetPeriod(b : byte; box, setcheck : boolean);
     procedure SetAction(b : byte; box : boolean);
     procedure SetCat(b : byte; box : boolean);
     procedure SetCycle(w : word; box : boolean);
     procedure SetDuration(w : dword; box : boolean);
     procedure GetDuration;
     procedure CallEdit;
     procedure DelFil;
     procedure Act(a : dword);
     procedure PlusYear;
     procedure MinusYear;
     procedure KalSet;
     procedure WindowProcedure(var Msg : TMessage); override;
     procedure   DisplayWD;
     procedure   MemWD;
     procedure   ok(clos : boolean);
     procedure   Tomorrow;
     procedure   test;
     function    Tab : boolean;
     procedure   PlusTab;
     procedure   MinusTab;
     procedure   HotList(SaveTrue : boolean);
     procedure   recfil;
     end;

var
     alarmdlg : MyAlarmDlg;

implementation

uses application, actions, inbx, myee;

procedure MyAlarmDlg.FullQuad;
begin
qd[1].r.left   := 43; qd[1].r.top    := 344; qd[1].r.width  := 35; qd[1].r.height := 25; qd[1].enable   := true;
qd[1].a        := 400; // help

qd[2].r.left   := 478; qd[2].r.top    := 344; qd[2].r.width  := 35; qd[2].r.height := 25; qd[2].enable   := true;
qd[2].a        := 401; // ok

qd[3].r.left   := 418; qd[3].r.top    := 344; qd[3].r.width  := 35; qd[3].r.height := 25; qd[3].enable   := true;
qd[3].a        := 402; // add

qd[4].r.left   := 358; qd[4].r.top    := 344; qd[4].r.width  := 35; qd[4].r.height := 25; qd[4].enable   := true;
qd[4].a        := 403; // cancel

qd[5].r.left   := 528; qd[5].r.top    := 300; qd[5].r.width  := 18; qd[5].r.height := 21; qd[5].enable   := true;
qd[5].a        := 404; // add input string

qd[6].r.left   := 125; qd[6].r.top    := 12; qd[6].r.width  := 38; qd[6].r.height := 18; qd[6].enable   := true;
qd[6].a        := 405; // {-} year

qd[7].r.left   := 240; qd[7].r.top    := 12; qd[7].r.width  := 38; qd[7].r.height := 18; qd[7].enable   := true;
qd[7].a        := 406; // {+} year

qd[8].r.left   := 126; qd[8].r.top    := 267; qd[8].r.width  := 18; qd[8].r.height := 18; qd[8].enable   := true;
qd[8].a        := 407; // record

qd[9].r.left   := 148; qd[9].r.top    := 267; qd[9].r.width  := 18; qd[9].r.height := 18; qd[9].enable   := true;
qd[9].a        := 408; // stop

qd[10].r.left   := 167; qd[10].r.top    := 267; qd[10].r.width  := 18; qd[10].r.height := 18; qd[10].enable   := true;
qd[10].a        := 409; // play

qd[11].r.left   := 171; qd[11].r.top    := 172; qd[11].r.width  := 59; qd[11].r.height := 20; qd[11].enable   := true;
qd[11].a        := 410; // eye

qd[12].r.left   := 234; qd[12].r.top    := 172; qd[12].r.width  := 45; qd[12].r.height := 20; qd[12].enable   := true;
qd[12].a        := 411; // sale

qd[20].r.left   := 297; qd[20].r.top    := 14; qd[20].r.width  := 30; qd[20].r.height := 20; qd[20].enable   := true;
qd[20].a        := 10; // m10
qd[21].r.left   := 297; qd[21].r.top    := 36; qd[21].r.width  := 30; qd[21].r.height := 20; qd[21].enable   := true;
qd[21].a        := 20; // m20
qd[22].r.left   := 297; qd[22].r.top    := 60; qd[22].r.width  := 30; qd[22].r.height := 20; qd[22].enable   := true;
qd[22].a        := 30; // m30
qd[23].r.left   := 297; qd[23].r.top    := 84; qd[23].r.width  := 30; qd[23].r.height := 20; qd[23].enable   := true;
qd[23].a        := 40; // m40
qd[24].r.left   := 297; qd[24].r.top    := 106; qd[24].r.width  := 30; qd[24].r.height := 20; qd[24].enable   := true;
qd[24].a        := 50; // m50

qd[25].r.left   := 339; qd[25].r.top    := 12; qd[25].r.width  := 24; qd[25].r.height := 20; qd[25].enable   := true;
qd[25].a        := 101; // m01
qd[26].r.left   := 339; qd[26].r.top    := 36; qd[26].r.width  := 24; qd[26].r.height := 20; qd[26].enable   := true;
qd[26].a        := 102; // m02
qd[27].r.left   := 339; qd[27].r.top    := 60; qd[27].r.width  := 24; qd[27].r.height := 20; qd[27].enable   := true;
qd[27].a        := 103; // m03
qd[28].r.left   := 339; qd[28].r.top    := 84; qd[28].r.width  := 24; qd[28].r.height := 20; qd[28].enable   := true;
qd[28].a        := 104; // m04
qd[29].r.left   := 339; qd[29].r.top    := 106; qd[29].r.width  := 24; qd[29].r.height := 20; qd[29].enable   := true;
qd[29].a        := 105; // m05
qd[30].r.left   := 364; qd[30].r.top    := 12; qd[30].r.width  := 24; qd[30].r.height := 20; qd[30].enable   := true;
qd[30].a        := 106; // m06
qd[31].r.left   := 364; qd[31].r.top    := 36; qd[31].r.width  := 24; qd[31].r.height := 20; qd[31].enable   := true;
qd[31].a        := 107; // m07
qd[32].r.left   := 364; qd[32].r.top    := 60; qd[32].r.width  := 24; qd[32].r.height := 20; qd[32].enable   := true;
qd[32].a        := 108; // m08
qd[33].r.left   := 364; qd[33].r.top    := 84; qd[33].r.width  := 24; qd[33].r.height := 20; qd[33].enable   := true;
qd[33].a        := 109; // m09
qd[34].r.left   := 364; qd[34].r.top    := 106; qd[34].r.width  := 24; qd[34].r.height := 20; qd[34].enable   := true;
qd[34].a        := 100; // m00

qd[35].r.left   := 403; qd[35].r.top    := 14; qd[35].r.width  := 25; qd[35].r.height := 20; qd[35].enable   := true;
qd[35].a        := 200; // h00
qd[36].r.left   := 437; qd[36].r.top    := 14; qd[36].r.width  := 25; qd[36].r.height := 20; qd[36].enable   := true;
qd[36].a        := 201; // h01
qd[37].r.left   := 471; qd[37].r.top    := 14; qd[37].r.width  := 25; qd[37].r.height := 20; qd[37].enable   := true;
qd[37].a        := 202; // h02
qd[38].r.left   := 503; qd[38].r.top    := 14; qd[38].r.width  := 25; qd[38].r.height := 20; qd[38].enable   := true;
qd[38].a        := 203; // h03

qd[39].r.left   := 403; qd[39].r.top    := 36; qd[39].r.width  := 25; qd[39].r.height := 20; qd[39].enable   := true;
qd[39].a        := 204; // h04
qd[40].r.left   := 437; qd[40].r.top    := 36; qd[40].r.width  := 25; qd[40].r.height := 20; qd[40].enable   := true;
qd[40].a        := 205; // h05
qd[41].r.left   := 471; qd[41].r.top    := 36; qd[41].r.width  := 25; qd[41].r.height := 20; qd[41].enable   := true;
qd[41].a        := 206; // h06
qd[42].r.left   := 503; qd[42].r.top    := 36; qd[42].r.width  := 25; qd[42].r.height := 20; qd[42].enable   := true;
qd[42].a        := 207; // h07

qd[43].r.left   := 403; qd[43].r.top    := 60; qd[43].r.width  := 25; qd[43].r.height := 20; qd[43].enable   := true;
qd[43].a        := 208; // h08
qd[44].r.left   := 437; qd[44].r.top    := 60; qd[44].r.width  := 25; qd[44].r.height := 20; qd[44].enable   := true;
qd[44].a        := 209; // h09
qd[45].r.left   := 471; qd[45].r.top    := 60; qd[45].r.width  := 25; qd[45].r.height := 20; qd[45].enable   := true;
qd[45].a        := 210; // h10
qd[46].r.left   := 503; qd[46].r.top    := 60; qd[46].r.width  := 25; qd[46].r.height := 20; qd[46].enable   := true;
qd[46].a        := 211; // h11

qd[47].r.left   := 403; qd[47].r.top    := 87; qd[47].r.width  := 25; qd[47].r.height := 20; qd[47].enable   := true;
qd[47].a        := 212; // h12
qd[48].r.left   := 437; qd[48].r.top    := 87; qd[48].r.width  := 25; qd[48].r.height := 20; qd[48].enable   := true;
qd[48].a        := 213; // h13
qd[49].r.left   := 471; qd[49].r.top    := 87; qd[49].r.width  := 25; qd[49].r.height := 20; qd[49].enable   := true;
qd[49].a        := 214; // h14
qd[50].r.left   := 503; qd[50].r.top    := 87; qd[50].r.width  := 25; qd[50].r.height := 20; qd[50].enable   := true;
qd[50].a        := 215; // h15

qd[51].r.left   := 403; qd[51].r.top    := 111; qd[51].r.width  := 25; qd[51].r.height := 20; qd[51].enable   := true;
qd[51].a        := 216; // h16
qd[52].r.left   := 437; qd[52].r.top    := 111; qd[52].r.width  := 25; qd[52].r.height := 20; qd[52].enable   := true;
qd[52].a        := 217; // h17
qd[53].r.left   := 471; qd[53].r.top    := 111; qd[53].r.width  := 25; qd[53].r.height := 20; qd[53].enable   := true;
qd[53].a        := 218; // h18
qd[54].r.left   := 503; qd[54].r.top    := 111; qd[54].r.width  := 25; qd[54].r.height := 20; qd[54].enable   := true;
qd[54].a        := 219; // h19

qd[55].r.left   := 403; qd[55].r.top    := 134; qd[55].r.width  := 25; qd[55].r.height := 20; qd[55].enable   := true;
qd[55].a        := 220; // h20
qd[56].r.left   := 437; qd[56].r.top    := 134; qd[56].r.width  := 25; qd[56].r.height := 20; qd[56].enable   := true;
qd[56].a        := 221; // h21
qd[57].r.left   := 471; qd[57].r.top    := 134; qd[57].r.width  := 25; qd[57].r.height := 20; qd[57].enable   := true;
qd[57].a        := 222; // h22
qd[58].r.left   := 503; qd[58].r.top    := 134; qd[58].r.width  := 25; qd[58].r.height := 20; qd[58].enable   := true;
qd[58].a        := 223; // h23

end;

constructor MyAlarmDlg.Create;
begin
     efAld := true;
     num := n;

case num of
0            : begin
obj.Reset;
// if obj.number = 0 then begin
obj.year   := app.stat.year;
obj.month  := app.stat.month;
obj.day    := app.stat.day;
obj.hour   := app.stat.hour;
obj.minute := app.stat.minute;
// end; {end if}
end;
$FFFFFFFF    : begin end;
else
               obj := app.org.w[num]
end; {end select}

FullQuad;

am_calendar := app.tun.engtrue_calend_fmt;
inherited Create(hDesktopWindow);
end;

procedure MyAlarmDlg.full;
  var
    capsiz : integer;
begin inherited;
capsiz := GetSystemMetrics(SM_CYCAPTION);
self.FWidth  := adlg_w;
self.FHeight := adlg_h + capsiz;
self.Ftop    := app.sc_h div 2 - self.FHeight div 2;
self.Fleft   := app.sc_w div 2 - self.FWidth  div 2;
self.WindowClassEx.hbrBackground := CreateSolidBrush(colr_my);
{createwindow}
{createwindowex}
FStyle := WS_VISIBLE or WS_SYSMENU or WS_MINIMIZEBOX;
FExStyle := WS_EX_APPWINDOW;
WindowClassEx.hInstance := app.hinstance;
FCaption := PCHar(alr_capt_capt);
WindowClassEx.hIcon := app.hi_buran;
end;

procedure MyAlarmDlg.aftercreate;
  var
    f : longint;
begin
htype     := ComboBox.Create(hwnd, app.hinstance, '', 275, 300, 250, 300, false, false, false, false, false, false, event_pmaxmesslen);
             HotList(false);
hdescript := ComboBox.Create(hwnd, app.hinstance, '', 120, 300, 145, 450, false, true, false, false, false, true, 0);
for f := 0 to cat_max do ComboBox.Add(hdescript, cat_name[f]);

SendMessage(hdescript, WM_SETFONT, hf_my, MAKELPARAM(WORD(true), 0));

hact      := ComboBox.Create(hwnd, app.hinstance, '', 200, 265, 200, 380, false, true, false, false, false, true, 0);
for f := 0 to 9 do ComboBox.Add(hact, inttofix2str(f + 1) + '.' + action_name1[f]);
for f := 10 to 16 do ComboBox.Add(hact, action_name[f]);

hper      := ComboBox.Create(hwnd, app.hinstance, '', 410, 265, 129, 250, false, true, false, false, false, true, 0);
hcik      := ComboBox.Create(hwnd, app.hinstance, '', 492, 170, 48, 200, false, true, false, false, false, true, 0);
for f := 2 to cik_max do ComboBox.Add(hcik, IntToStr(f));
SendMessage(hcik, WM_SETFONT, hf_my, MAKELPARAM(WORD(true), 0));

   hi_gbar := EBmpCreate(hwnd, app.hinstance, 'MD', 10, 342{top}, false);
   hi_r    := EBmpCreate(hwnd, app.hinstance, 'RT', 529, 325{top}, false);
   hi_l    := EBmpCreate(hwnd, app.hinstance, 'LT', 0, 325{top}, false);

   hi_rsp  := EBmpCreate(hwnd, app.hinstance, 'KRPT', 129, 270{top}, false);

   hi_bok     := EBmpCreate(hwnd, app.hinstance, 'OKBUTTON', 480, 342{top}, false);
   hi_badd    := EBmpCreate(hwnd, app.hinstance, 'ADDBUTTON', 420, 342{top}, false);
   hi_bcancel := EBmpCreate(hwnd, app.hinstance, 'CANCELBUTTON', 360, 342{top}, false);
   hi_bhelp   := EBmpCreate(hwnd, app.hinstance, 'QBUTTON', 44, 342{top}, false);

   hi_bast   := EBmpCreate(hwnd, app.hinstance, 'ASTER', 534, 305{top}, false);
    if app.tun.engtrue_hour_fmt then
    hi_knopki := EBmpCreate(hwnd, app.hinstance, 'KNOPKIE', 290, 8{top}, false)
    else
    hi_knopki := EBmpCreate(hwnd, app.hinstance, 'KNOPKI', 290, 8{top}, false);
   hi_byear  := EBmpCreate(hwnd, app.hinstance, 'KNOPKIYEAR', 120, 8{top}, false);
   hi_other  := EBmpCreate(hwnd, app.hinstance, 'KNOPKIOTHER', 120, 164{top}, false);
   hi_bart   := EBmpCreate(hwnd, app.hinstance, 'BARH', 120, 204{top}, false);
   hi_barb   := EBmpCreate(hwnd, app.hinstance, 'BARH', 120, 255{top}, false);

SendMessage(htype, WM_SETFONT, hf_my, MAKELPARAM(WORD(true), 0));
SendMessage(hact, WM_SETFONT, hf_my, MAKELPARAM(WORD(true), 0));
SendMessage(hper, WM_SETFONT, hf_my, MAKELPARAM(WORD(true), 0));

hdr10000 := ComboBox.Create(hwnd, app.hinstance, '', 292, 170, 35, 200, false, true, false, false, false, true, 0);
         for f := 0 to 5 do ComboBox.Add(hdr10000, IntToStr(f));
hdr1000  := ComboBox.Create(hwnd, app.hinstance, '', 332, 170, 35, 200, false, true, false, false, false, true, 0);
         for f := 0 to 9 do ComboBox.Add(hdr1000, IntToStr(f));
hdr100   := ComboBox.Create(hwnd, app.hinstance, '', 372, 170, 35, 200, false, true, false, false, false, true, 0);
         for f := 0 to 9 do ComboBox.Add(hdr100, IntToStr(f));
hdr10    := ComboBox.Create(hwnd, app.hinstance, '', 412, 170, 35, 200, false, true, false, false, false, true, 0);
         for f := 0 to 9 do ComboBox.Add(hdr10, IntToStr(f));
hdr1     := ComboBox.Create(hwnd, app.hinstance, '', 452, 170, 35, 200, false, true, false, false, false, true, 0);
         for f := 0 to 9 do ComboBox.Add(hdr1, IntToStr(f));

SendMessage(hdr10000, WM_SETFONT, hf_my, MAKELPARAM(WORD(true), 0));
SendMessage(hdr1000, WM_SETFONT, hf_my, MAKELPARAM(WORD(true), 0));
SendMessage(hdr100, WM_SETFONT, hf_my, MAKELPARAM(WORD(true), 0));
SendMessage(hdr10, WM_SETFONT, hf_my, MAKELPARAM(WORD(true), 0));
SendMessage(hdr1, WM_SETFONT, hf_my, MAKELPARAM(WORD(true), 0));

hdel :=  CheckButton.Create(hwnd, app.hinstance, PCHar(alr_capt_del), 130, 212, 120, 20, false, false);
hdiz :=  CheckButton.Create(hwnd, app.hinstance, PCHar(alr_capt_diz), 260, 212, 120, 20, false, false);
hrtm :=  CheckButton.Create(hwnd, app.hinstance, PCHar(alr_capt_rtm), 390, 212, 150, 20, false, false);
hinf :=  CheckButton.Create(hwnd, app.hinstance, PCHar(alr_capt_inf), 130, 234, 200, 20, false, false);
hdisp := CheckButton.Create(hwnd, app.hinstance, PCHar(alr_capt_dsp), 335, 234, 190, 20, false, false);

hmonlist := ListBox.Create(hwnd, app.hinstance, '', 8, 8, 104, 200, false, false, false, true, false, true, true);
 SendMessage(hmonlist, LB_SETITEMHEIGHT, 0, MAKELPARAM(16, 0));

         for f := 1 to 12 do ListBox.Add(hmonlist, inttofix2str(f) + ' ' + mon_name[f]);

hkal     := ListBox.Create(hwnd, hinstance, '', 120, 40, 148, 119, false, true, false, false, false, true, true);

         SendMessage(hkal, LB_SETCOLUMNWIDTH, 24, 0);
         SendMessage(hkal, LB_SETITEMHEIGHT, 0, MAKELPARAM(16, 0));

hlistwd  := ListBox.Create(hwnd, hinstance, '', 267, 40, 18, 119, false, false, true, false, false, true, true);
 SendMessage(hlistwd, LB_SETITEMHEIGHT, 0, MAKELPARAM(16, 0));
if am_calendar then
 for f := 1 to 7 do ListBox.Add(hlistwd, swdne[f])
else
 for f := 1 to 7 do ListBox.Add(hlistwd, swdn[f]);

      DisplayWD;
    
for f := 0 to 10 do ComboBox.Add(hper, period_name[f]);

hyear :=  StaticText.Create(hwnd, app.hinstance, '', 161, 13, 80, 18, false);

      KalSet;
      SetDisplayYear(obj.year);
      ListBox.Select[hmonlist] := obj.month - 1;
      ListBox.Select[hkal] := obj.day + offset - 1;


htime :=  StaticText.Create(hwnd, app.hinstance, '', 303, 137{138}, 80, 18, false);
DisplayTime;

hfil  :=  ListBox.Create(hwnd, app.hinstance, '', 8, 215, 104, 110, false, false, false, false, false, true, true);
SendMessage(hfil, LB_SETITEMHEIGHT, 0, MAKELPARAM(16, 0));

      EnableWindow(hfil, false);

SetPeriod(obj.period, true, false);
SetCycle(obj.cycle, true);
SetCat(obj.cat, true);
SetWindowText(htype, PCHar(String(obj.mess)));
SetDisplay(obj.display);
SetRemove(obj.remove);
SetDisable(obj.disable);
SetRealtime(obj.realtime);
SetInfluence(obj.influence);
SetDuration(obj.duration, true);
if obj.Ex then SetAction(obj.action, true) else SetAction(app.tun.al_dlg_mem_action, true);
tab_number := 0;
tab;
end;

procedure MyAlarmDlg.OnClose; begin close; end;
procedure MyAlarmDlg.Close;
begin
 DeleteObject(WindowClassEx.hbrBackground);

 efAld := false;
 destroy;
end;

procedure MyAlarmDlg.OnLstCol;
{WM_CTLCOLORLISTBOX}
begin   SelectObject(msg.WParam, hf_my);
if (msg.LParam = hmonlist) or (msg.LParam = hkal) then begin
  msg.Result := DefWindowProc(hwnd, msg.msg, msg.WParam, msg.LParam);
  SetTextColor(msg.WParam, colr_bl);
  exit;
end; {end if hlistwd}

if msg.LParam = self.hlistwd then begin

//{-!-}   SelectObject(msg.WParam, hf_2);
   SetTextColor(msg.WParam, colr_yl);
   if msg.LParam = self.hlistwd then begin
    msg.Result := hb_rd;
       SetBkColor(msg.WParam, colr_rd);
    end else begin
       SetBkColor(msg.WParam, colr_db);
     msg.Result := hb_db
    end;
  exit;
end; {end if hlistwd}

{else}
msg.Result := DefWindowProc(hwnd, msg.msg, msg.WParam, msg.LParam);
  { msg.Result := hb_rd;
   SetBkColor(dc, colr_rd);}
   SetTextColor(msg.WParam, colr_bl);
//{-!-}   SelectObject(msg.WParam, hf_2);
   exit;
{end els}

// exit;
{msg.Result := hb_db;}
// msg.Result := DefWindowProc(hwnd, msg.msg, msg.WParam, msg.LParam);
end;

procedure MyAlarmDlg.OnEditCol;
begin
msg.Result := DefWindowProc(hwnd, msg.msg, msg.WParam, msg.LParam);
SetTextColor(msg.WParam, colr_bl);
end;

procedure MyAlarmDlg.OnStCol;
label lb_end;
begin
SelectObject(msg.WParam, hf_my);
if (msg.LParam = htime) or (msg.LParam = hyear) then begin
SetBkColor(msg.WParam, colr_my);
SetTextColor(msg.WParam, colr_bl);
goto lb_end;
end; {end if}

//{-!-} SelectObject(msg.WParam, hf_2);
 SetBkColor(msg.WParam, colr_my);
 SetTextColor(msg.WParam, colr_bl);

lb_end:
msg.Result := app.HBRUSH_MY;
end;

procedure MyAlarmDlg.OnPaint;
  {var
    r : TRect;
    m : MyRect;
    p : TPaintStruct;}
 {WM_PAINT}
begin
//DC := BeginPaint(hwnd, p);
//     m.left := 120;  m.top  := 8;
//     m.width := 164; m.height := 25;
//     r := MyRectToTRect(m); // year rect
//    DrawEdge(DC, r, BDR_SUNKENOUTER, BF_RECT);
//    SetTextColor(DC, colr_bl);
//    SetBkColor(DC, colr_my);
//    SetTextAlign(DC, TA_CENTER or VTA_CENTER);
//    SelectObject(DC, hf_sy{1});
//        TextOut(DC, 250, 9, '>', 1); TextOut(DC, 150, 9, '<', 1);
//     m.left := 411;  m.top  := 81;
//     m.width := 120; m.height := 4;
//EndPaint(hwnd, p);
DefWindowProc(hwnd, msg.msg, msg.WParam, msg.LParam);
msg.Result := 0;
end;

procedure MyAlarmDlg.SetRemove; begin  obj.remove := b; CheckButton.Check[hdel] := obj.remove; end;
procedure MyAlarmDlg.SetDisable; begin  obj.disable := b; CheckButton.Check[hdiz] := obj.disable; end;
procedure MyAlarmDlg.SetRealtime; begin  obj.realtime := b; CheckButton.Check[hrtm] := obj.realtime; end;
procedure MyAlarmDlg.SetInfluence; begin  obj.influence := b; CheckButton.Check[hinf] := obj.influence; end;
procedure MyAlarmDlg.SetDisplay; begin obj.display := b; CheckButton.Check[hdisp] := obj.display; end;
procedure MyAlarmDlg.SetDisplayYear; begin  SetWindowText(hyear, PCHar(inttostr(w))); end;

procedure MyAlarmDlg.DisplayTime;
 var
   s : string;
begin
s := GetLocalHour(app.tun.engtrue_hour_fmt, obj.hour) + ':' + inttofix2str(obj.minute);
SetWindowText(htime, PCHar(s));
end;

procedure MyAlarmDlg.OnCommand;
begin
if msg.Ctl = 0 then exit;

if msg.Ctl = hdel then SetRemove(not obj.remove);
if msg.Ctl = hdiz then SetDisable(not obj.disable);
if msg.Ctl = hrtm then SetRealtime(not obj.realtime);
if msg.Ctl = hinf then SetInfluence(not obj.influence);
if msg.Ctl = hdisp then SetDisplay(not obj.display);

case msg.NotifyCode of
     CBN_SELCHANGE  : begin
     if msg.Ctl = hper then SetPeriod(ComboBox.Select[hper], false, true);
     if msg.Ctl = htype then if not CheckButton.Check[hdisp] then SetDisplay(true);
     if msg.Ctl = hcik  then SetCycle(ComboBox.Select[hcik] + 2, false);
     if msg.Ctl = hdescript  then SetCat(ComboBox.Select[hdescript], false);
     if msg.Ctl = hkal then begin
        if ListBox.Select[hkal] < offset then
        begin
        ListBox.Select[hkal] := offset;
        obj.day := 1;
        end else obj.day := ListBox.Select[hkal] - offset + 1;

 //           dint(obj.day);
                            end;
     if msg.Ctl = hmonlist then begin
     // beep;
     obj.month := ListBox.Select[hmonlist] + 1;
     kalset;
     ListBox.Select[hkal] := offset;
     obj.day := 1;
                                end;
     if msg.Ctl = self.hact then begin
     SetAction(ComboBox.Select[hact], false);
     end; {end if}
     if msg.Ctl = hlistwd then MemWD;

     if (msg.Ctl = hdr10000) or (msg.Ctl = hdr1000)
     or (msg.Ctl = hdr100) or (msg.Ctl = hdr10)
     or (msg.Ctl = hdr1) then begin
     GetDuration;
     end; {end if}

     if msg.Ctl = hfil then begin
      if ListBox.Select[hfil] > -1 then
      obj.filn := ListBox.GetItemText(hfil, ListBox.Select[hfil]) else
       obj.filn := '';
     end;
                      end;

     CBN_EDITCHANGE : begin
     if msg.Ctl = htype then if GetWindowTextLength(htype) = 0 then SetDisplay(false) else if not CheckButton.Check[hdisp] then SetDisplay(true);
                      end;

     LBN_DBLCLK     : begin
     if msg.Ctl = hfil  then CallEdit;
                      end;
end; {end select}
end;

procedure MyAlarmDlg.SetAction;
begin
if not box then if obj.action <> b then obj.filn := '';
 obj.action := b;
 if box then ComboBox.Select[hact] := obj.action;

 ListBox.Clear(hfil);
 case obj.action of
 13            : begin ListBox.MyFileList(hfil, s_dir, '*.wav'); ListBox.Enable[hfil] := true; end;
 14            : begin ListBox.MyFileList(hfil, b_dir, '*.bat'); ListBox.Enable[hfil] := true; end;
 else
               ListBox.Enable[hfil] := false;
 end; {end select}
 case obj.action of
 13,14         : SetVisFil;
 end; {end select}
end;

procedure MyAlarmDlg.SetCat;
begin
 obj.cat := b;
 if box then ComboBox.Select[hdescript] := obj.cat;
end;

procedure MyAlarmDlg.SetPeriod;
begin
obj.period := b;
case obj.period of
     0: begin // odnokratno
     SetVisCtl(bit4 or bit5 or bit6 or bit7 or bit8 or bit9 or bit12 or bit20);
     if setcheck then SetRemove(true);
        end;
     1: begin // ezhechasno
     SetVisCtl(bit8);
     if setcheck then SetRemove(false);
     if setcheck then SetRealtime(true);
     if setcheck then SetInfluence(false);
        end;
     2: begin // ezhednevno
     SetVisCtl(bit8 or bit9 or bit6 or bit12 or bit20);
     if setcheck then SetRemove(false);
        end;
     3: begin // dni nedeli
     SetVisCtl(bit8 or bit9 or bit6 or bit12 or bit20);
     if setcheck then SetRemove(false);
        end;
     4: begin // chislo mesjaca
     SetVisCtl(bit4 or bit5 or bit6 or bit8 or bit9 or bit12 or bit20);
     if setcheck then SetRemove(false);
        end;
     5, 6: begin // chjetnye, nechjetye
     SetVisCtl(bit8 or bit9 or bit6 or bit12 or bit20);
     if setcheck then SetRemove(false);
        end;
     7, 8: begin // ezhegodnye, yubilei
     SetVisCtl(bit4 or bit5 or bit6 or bit8 or bit9 or bit12 or bit20);
     if setcheck then SetRemove(false);
        end;
     9: begin // reguljarnye dni
     SetVisCtl(bit4 or bit5 or bit6 or bit8 or bit9 or bit10 or bit12 or bit20);
     if setcheck then SetRemove(false);
        end;
     10: begin // reguljarnye chasy
     SetVisCtl(bit4 or bit5 or bit6 or bit8 or bit9 or bit10 or bit20);
     if setcheck then SetRemove(false);
        end;

end; {end select}
if box then ComboBox.Select[hper] := obj.period;
end;

procedure MyAlarmDlg.SetCycle; begin obj.cycle := w; if box then ComboBox.Select[hcik] := obj.cycle - 2; end;
procedure MyAlarmDlg.GetDuration;
begin
obj.duration := ComboBox.Select[self.hdr10000] * 10000 +
                ComboBox.Select[self.hdr1000]  * 1000  +
                ComboBox.Select[self.hdr100]   * 100   +
                ComboBox.Select[self.hdr10]    * 10    +
                ComboBox.Select[self.hdr1];
end;
procedure MyAlarmDlg.SetDuration;
  var
    tmp10000, tmp1000, tmp100, tmp10, tmp1 : dword;
begin
obj.duration := w;
if box then begin
tmp10000 := w div 10000;
tmp1000  := (w - tmp10000 * 10000) div 1000;
tmp100   := (w - (tmp10000 * 10000) - (tmp1000 * 1000)) div 100;
tmp10    := (w - (tmp10000 * 10000) - (tmp1000 * 1000) - (tmp100 * 100)) div 10;
tmp1     := (w - (tmp10000 * 10000) - (tmp1000 * 1000) - (tmp100 * 100) - (tmp10 * 10));

ComboBox.Select[self.hdr10000] := tmp10000;
ComboBox.Select[self.hdr1000]  := tmp1000;
ComboBox.Select[self.hdr100]   := tmp100;
ComboBox.Select[self.hdr10]    := tmp10;
ComboBox.Select[self.hdr1]     := tmp1;
end; {end if}
end;

procedure MyAlarmDlg.SetVisCtl;
          procedure SetVisDur(a : boolean);
          begin
          ComboBox.Enable[hdr1] := a;
          ComboBox.Enable[hdr10] := a;
          ComboBox.Enable[hdr100] := a;
          ComboBox.Enable[hdr1000] := a;
          ComboBox.Enable[hdr10000] := a;
          end;
begin
// ListBox.Enable[hkal]      := a and bit4 <> 0;
// ListBox.Enable[hmonlist]  := a and bit5 <> 0;
CheckButton.Enable[hrtm]  := a and bit6 <> 0;
CheckButton.Enable[hdel]  := a and bit7 <> 0;
CheckButton.Enable[hdiz]  := a and bit8 <> 0;
CheckButton.Enable[hinf]  := a and bit9 <> 0;
ComboBox.Enable[hcik]     := a and bit10 <> 0;
// StaticText.Visible[htime] := a and bit20 <> 0;
                          SetVisDur(a and bit12 <> 0);
end;

procedure MyAlarmDlg.OnLMouseUp;
 var
   h, v : integer;
   f         : dword;

 function chpok(a : MyQuad) : boolean;
 begin result := ((a.r.left <= h) and (a.r.left + a.r.width >= h)) and
 ((a.r.top <= v) and (a.r.height + a.r.top >= v)); end;

 procedure vc(a : MyQuad); var dc, hreg : THandle; r : TRect;
 begin  dc := GetDC(hwnd);
  r := MyRectToTRect(a.r);
  hreg :=  CreateRoundRectRgn(r.Left, r.top, r.Right, r.Bottom, 15, 15);
  SelectObject(dc, hreg);
   InvertRgn(dc, hreg);
     Sleep(110);
   InvertRgn(dc, hreg);
  DeleteObject(hreg);
  ReleaseDC(hwnd, dc);
 end;
{WM_LBUTTONUP}
begin
h :=  LOWORD(msg.LParam); v  := HIWORD(msg.LParam);

for f := 0 to qd_count do begin
if chpok(qd[f]) and qd[f].enable then begin
 vc(qd[f]);
 act(qd[f].a);
 break;
end; {end if}
end; {next f}
end;

procedure MyAlarmDlg.Act;
begin
case a of
     10..50:   begin
     obj.minute := a;
     DisplayTime;
     end;
     100:      begin
     obj.minute := 0;
     DisplayTime;
     end;
     101..109: begin
     obj.minute := (obj.minute div 10) * 10 + a - 100;
     DisplayTime;
     end;
     200..223: begin
     obj.hour := a - 200;
     DisplayTime;
     end;
     400: app.ShowHelp(1);
     401:      begin
       ok(true);

     end;
     402:      begin
       ok(false);

     end;
     403:      begin
     Close;
     end;
     404:      HotList(true);
     405:      minusyear;
     406:      plusyear;
     407:      recfil;
     408:      StopSnd;
     409:      test;
     410:      begin     eeev := obj;
     app.org.ShowEE(103);
     end;
     411:      Tomorrow;


end; {end select}
end;

procedure MyAlarmDlg.PlusYear;
begin
if not ListBox.Enable[hmonlist] then exit;
 if obj.year < 9998 then inc(obj.year) else begin beep; exit; end;
 SetDisplayYear(obj.year);
 obj.month := 1;
 ListBox.Select[hmonlist] := obj.month - 1;
 obj.day := 1;
 kalset;
 ListBox.Select[hkal] := offset + obj.day - 1;
end;

procedure MyAlarmDlg.MinusYear;
begin
if not ListBox.Enable[hmonlist] then exit;
 if obj.year > 2 then dec(obj.year) else begin beep; exit; end;
 SetDisplayYear(obj.year);
 obj.month := 1;
 ListBox.Select[hmonlist] := obj.month - 1;
 obj.day := 1;
 kalset;
 ListBox.Select[hkal] := offset + obj.day - 1;
end;

procedure MyAlarmDlg.KalSet;
const  monl : array [1..12] of byte =(31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31); // len months
 var
   lmon : byte;
   f : longint;
begin
  ListBox.Clear(hkal);
  offset := fdnd(obj.year, obj.month, 1) - 1;

   if am_calendar then begin
    if offset < 6 then begin
       offset := offset + 1;
    end else begin
       offset := 0;
    end; {end if}
   end; {end if}

lmon := monl[obj.month];
if (((obj.year mod 4) = 0) and (obj.month = 2)) then lmon := 29;
if offset > 0 then
 for f := 1 to offset do ListBox.Add(hkal, '');
for f := 1 to lmon do ListBox.Add(hkal, ' ' + inttostr(f));
end;

procedure MyAlarmDlg.WindowProcedure(var Msg : TMessage);
  var
    d : TDecodeKey; ctrl, shift : boolean;
begin

case msg.Msg of
     WM_KEYDOWN: begin
      d := DecodeKey(msg.WParam, msg.LParam);

      ctrl := GetAsyncKeyState(VK_CONTROL) = -32768;
      shift   := GetAsyncKeyState(VK_SHIFT)   = -32768;

           msg.result := 0;
         // dint(d.virt);
      case d.virt of
       VK_RETURN : begin
       if not d.downbefore then if ctrl then ok(false) else ok(true);
       msg.result := 1; end;
       VK_ESCAPE : begin close; msg.Result := 1; end;
       VK_F1     : begin msg.Result := 1; end;
       VK_F5     : if CheckButton.Enable[hinf] then SetInfluence(not obj.influence);
       VK_F6     : SetDisplay(not obj.display);
       VK_F7     : SetDisable(not obj.disable);
       VK_F8     : if CheckButton.Enable[hdel] then SetRemove(not obj.remove);
       VK_F9     : if CheckButton.Enable[hrtm] then SetRealtime(not obj.realtime);
       VK_PRIOR  : if ctrl then begin if obj.minute < 59 then inc(obj.minute) else obj.minute := 0; DisplayTime; msg.Result := 1; end;
       VK_NEXT   : if ctrl then begin if obj.minute > 0 then dec(obj.minute) else obj.minute := 59; DisplayTime; msg.Result := 1; end;
       VK_HOME   : if ctrl then begin if obj.hour < 23 then inc(obj.hour) else obj.hour := 0; DisplayTime; msg.Result := 1; end;
       VK_END    : if ctrl then begin if obj.hour > 0 then dec(obj.hour) else obj.hour := 23; DisplayTime; msg.Result := 1; end;
       VK_INSERT : if ctrl and shift then begin plusyear; msg.Result := 1; end;
       VK_DELETE : if ctrl and shift then begin minusyear; msg.Result := 1; end else
       if ctrl then begin DelFil; msg.Result := 1; end;
       VK_TAB    : begin
       if ctrl then MinusTab else PlusTab;
                   msg.Result := 1;
                 end;
       68, 82, 83, 84 : if ctrl then msg.Result := 1;
{      else
          msg.result := 0;}
      end; {end select}

     end;

     WM_KEYUP: begin

      d := DecodeKey(msg.WParam, msg.LParam);
      ctrl := GetAsyncKeyState(VK_CONTROL) = -32768;
      shift   := GetAsyncKeyState(VK_SHIFT)   = -32768;

      case d.virt of
       VK_RETURN : begin

       msg.result := 1; end;
           68    : if ctrl then begin Tomorrow; msg.Result := 1; end;
           83    : if ctrl then begin  StopSnd; end;
           82    : if ctrl then begin  recfil;  end;
           84    : if ctrl then begin  test;    end;
       VK_F1     : app.ShowHelp(1);
       VK_F2     : HotList(true);
      else
          msg.result := 0;
      end; {end select}
               end;
else
    Dispatch(msg);
end; {end select}
end;

procedure MyAlarmDlg.DisplayWD;
  var
    f, tmp : byte;
begin
tmp := obj.wd;
 if am_calendar then begin
 asm
     push ax
     mov  al,  tmp
     mov  ah,  al
     and  al,  Byte(bit7)
     shl  al,  1
     or   ah,  al
     rol  ah,  1
     mov  tmp, ah
     pop  ax
 end; {end asm}
 end;
 for f := 0 to 6 do ListBox.ItemSelect[hlistwd, f] := ((1 and (tmp shr f)) = 1);
end;
procedure MyAlarmDlg.MemWD;
  var
    f : byte;
begin obj.wd := 0;
  for f := 0 to 6 do if ListBox.ItemSelect[hlistwd, f] then obj.wd := obj.wd or (1 shl f);
 if am_calendar then begin
 asm
     push ax
     mov  al, obj.wd
     mov  ah, al
     and  al, Byte(bit1)
     shl  al, 7
     or   ah, al
     ror  ah, 1
     mov  obj.wd, ah
     pop  ax
 end; {end asm}
 end; {end if}
end;

procedure   MyAlarmDlg.ok;
begin
  obj.mess := ComboBox.Text[htype];
//  if not obj.Ex then app.tun.al_dlg_mem_action := obj.action;
  if app.org.Save(num, hwnd) then exit;
  if efEE then SendMessage(hEE, WM_EUREKA, 0, 0);
  if clos then close;
  num := 0; obj.number := num;
end;

procedure   MyAlarmDlg.Tomorrow;
begin
obj := obj.PlusDay;
DisplayTime;
SetDisplayYear(obj.year);
ListBox.Select[hmonlist] := obj.month - 1;
KalSet;
ListBox.Select[hkal] := obj.day + offset - 1;
Sleep(200);
end;

procedure MyAlarmDlg.test;
begin
 run(obj, true);
end;

function  MyAlarmDlg.Tab;
begin
result := false;
case tab_number of
0:  SetFocus(htype);
1:  SetFocus(hper);
2:  SetFocus(hmonlist);
3:  SetFocus(hkal);
4:  SetFocus(hlistwd);
5:  SetFocus(hact);
6:  SetFocus(hdescript);////
7:  if (ComboBox.Visible[hdr1] and ComboBox.Enable[hdr1]) then SetFocus(hdr1) else result := true;
8:  if (ComboBox.Visible[hdr10] and ComboBox.Enable[hdr10]) then SetFocus(hdr10) else result := true;
9:  if (ComboBox.Visible[hdr100] and ComboBox.Enable[hdr100]) then SetFocus(hdr100) else result := true;
10: if (ComboBox.Visible[hdr1000] and ComboBox.Enable[hdr1000]) then SetFocus(hdr1000) else result := true;
11: if (ComboBox.Visible[hdr10000] and ComboBox.Enable[hdr10000]) then SetFocus(hdr10000) else result := true;
12: if (ComboBox.Visible[hcik] and ComboBox.Enable[hcik]) then SetFocus(hcik) else result := true;
13: if (ComboBox.Visible[hfil] and ComboBox.Enable[hfil]) then SetFocus(hfil) else result := true;
else
 tab_number := 0;
 tab;
end; {end select}
end;

procedure MyAlarmDlg.PlusTab;
begin
  inc(tab_number);
  if tab_number > tab_count then tab_number := 0;
  while tab do inc(tab_number);
end;
procedure MyAlarmDlg.MinusTab;
begin
  dec(tab_number);
  if tab_number < 0 then tab_number := tab_count;
  while tab do dec(tab_number);
end;

procedure MyAlarmDlg.HotList;
  var
    s : string;
begin
if savetrue then begin
s := ComboBox.Text[htype];
if s = '' then exit;
ComboBox.Insert(htype, 0, s);
if ComboBox.FileSave(htype, hm_fn, true, false, 100) then halt;
ComboBox.FileLoad(htype, hm_fn, false, 100);
ComboBox.Text[htype] := s;
end else begin
ComboBox.FileLoad(htype, hm_fn, false, 100);
end; {end if}
end;

procedure MyAlarmDlg.SetVisFil;
  var l, f : longint;
begin
  l := ListBox.Count(hfil);
  if l > -1 then
  for f := 0 to l - 1 do begin
     if ListBox.GetItemText(hfil, f) = obj.filn then begin ListBox.Select[hfil] := f; break; end;
  end; {next f}
end;


procedure a(parstr : string);
begin
    shell('sndrec32.exe', PCHar(parstr), 1);
sleep(1800);
    keybd_event(32, lo(MapVirtualKey(32, 0)), 0, 0); // KEY DOWN
    keybd_event(32, lo(MapVirtualKey(32, 0)), KEYEVENTF_KEYUP, 0);
end; {end a}

procedure MyAlarmDlg.recfil;
label eerr;
const nulwav : array[0..57] of byte =
(82,73,70,70,50,0,0,0,87,65,86,69,102,109,116,32,
18,0,0,0,1,0,1,0,34,86,0,0,34,86,0,0,1,0,8,0,40,
0,102,97,99,116,4,0,0,0,0,0,0,0,100,97,116,97,0,0,0,0);
  var
    fp : file of byte;
    fn, es : string;
    f, ff : word;

begin

if obj.action = 13 then begin /////////////

for f := 0 to 1999 do begin
fn := s_dir + 'V' + inttostr(f) + '.wav';
                   obj.filn := 'V' + inttostr(f);
assignfile(fp, fn);
{$I-}
reset(fp);
{$I+}
if IOResult <> 0 then begin
{$I-}
 rewrite(fp);
{$I+} if IOResult <> 0 then begin es := 'Error [RewriteWavFil]'; goto eerr; end;
end; {end if}

if FileSize(fp) = 0 then begin
for ff := 0 to 57 do begin
{$I-}
  write(fp, nulwav[ff]);
{$I+} if IOResult <> 0 then begin es := 'Error [WriteWavFil(1)]'; goto eerr; end;
end; {next ff}
{$I-}
 closefile(fp);
{$I+} if IOResult <> 0 then begin es := 'Error [CloseWavFil(1)]'; goto eerr; end;
SetAction(obj.action, false);
a(fn);
exit;
end;

{$I-}
closefile(fp);
{$I+} if IOResult <> 0 then begin es := 'Error [CloseWavFil(2)]'; goto eerr; end;
end; {next f}
MessageBox(hwnd, PCHar(alr_wav_big), PCHar(app_name), bit5);
end; {end if}  ////////////////////////////////////
if obj.action = 14 then begin /////////////

 if not GetUserStrExecute(hwnd, alr_fdlg_capt, cmn_str_bad_symbols_in_file_name, str_oc[true], str_oc[false], 8, 1, fn)
    then exit;
 if (fn = '') or (fn = ' ') or (fn = '  ') or (fn = '   ') or (fn = '    ') or (fn = '     ') or (fn = '      ') or (fn = '       ') or (fn = '        ') then exit;

 for ff := 1 to length(fn) do begin
  if (fn[ff] = '+') or
     (fn[ff] = '.') or
     (fn[ff] = '%') or
     (fn[ff] = '?') or
     (fn[ff] = '/') or
     (fn[ff] = '|') or
     (fn[ff] = '\') or
     (fn[ff] = '*') or
     (fn[ff] = '<') or
     (fn[ff] = '>') then begin
   MessageBox(hwnd, PCHar(cmn_str_bad_symbols_in_file_name), PCHar(app_name), bit5);
   exit;
  end; {end if}
 end; {next ff}

obj.filn := fn;
fn := b_dir + fn + '.bat';

assignfile(fp, fn);
{$I-}
reset(fp);
{$I+}
if IOResult <> 0 then begin
{$I-}
 rewrite(fp);
{$I+} if IOResult <> 0 then begin es := 'Error [RewriteBatFil]'; goto eerr; end;
end; {end if}

{$I-}
closefile(fp);
{$I+} if IOResult <> 0 then begin es := 'Error [CloseBatFil]'; goto eerr; end;

SetAction(obj.action, false);

Shell('notepad.exe', PCHar(fn), SW_SHOW);

end; {end if} /////////////////////////////////////
exit;
eerr:
{$I-}
closefile(fp);
{$I+} IOResult;
MessageBox(hwnd, PCHar(es), 'IO Error', bit5);
end; {end recfil}

procedure MyAlarmDlg.CallEdit;
  var     s : string; l : longint;
begin     l := ListBox.Select[hfil];
if l < 0 then exit;
s := ListBox.GetItemText(hfil, l);
if obj.action = 13 then Shell('sndrec32.exe', PCHar(s_dir + s + '.wav'), SW_SHOW);
if obj.action = 14 then Shell('notepad.exe', PCHar(b_dir + s + '.bat'), SW_SHOW);
end;
procedure MyAlarmDlg.DelFil;
  var     s : string; l : longint;
begin     l := ListBox.Select[hfil];
if l < 0 then exit;
s := ListBox.GetItemText(hfil, l);
if MessageBox(hwnd, PCHar(conf_del_fil + s), conf_capt_del_fil, bit5 or bit6 or bit3) <> idYes then exit;
if obj.action = 13 then Windows.DeleteFile(PCHar(s_dir + s + '.wav'));
if obj.action = 14 then Windows.DeleteFile(PCHar(b_dir + s + '.bat'));
SetAction(obj.action, false);
end;

end.
