unit cdialogs;

interface
           uses windows, commdlg, messages, myutils, dbg;


type
      MyFileDlg = class(TObject)
      ta       : array[0..260] of char;
      FileName : string;
      p : TOpenFileName;
      protected

      private

      public
        function GetFileName(
        hwnd, happ     : THandle;
        Filter         : string;
        FilterIndex    : dword;    // 1..2..3
        DefExt         : string;
        InitialDir     : string;
        SaveTrue       : boolean;
        Title          : string
        ) : boolean;
      end;

implementation

function MyFileDlg.GetFileName;
begin p.hWndOwner             := hwnd; p.hInstance           := happ;

if filter = '' then p.lpstrFilter := nil
  else p.lpstrFilter := PCHar(filter); // 'Text'#0'*.TXT'#0'All'#0'*.*'#0 if nil then none
p.nFilterIndex       := FilterIndex;

p.lpstrCustomFilter  := nil; p.nMaxCustFilter     := 0;

ta[1] := #0;                 // nil if not need select init position
p.lpstrFile          := ta;  p.nMaxFile           := 260;
p.lpstrFileTitle     := nil; p.nMaxFileTitle      := 260;
if InitialDir = '' then p.lpstrInitialDir := nil else p.lpstrInitialDir    := PCHar(InitialDir); // nil - cur dir;
if Title = ''      then p.lpstrTitle      := nil else p.lpstrTitle := PCHar(Title);
p.Flags  :=
         OFN_FILEMUSTEXIST or
         OFN_EXPLORER or
         OFN_EXTENSIONDIFFERENT or
         OFN_HIDEREADONLY or
         OFN_NONETWORKBUTTON or
         OFN_OVERWRITEPROMPT;

p.nFileOffset        := 0;   p.nFileExtension     := 0;  // offset !!!

if DefExt = '' then p.lpstrDefExt  := nil else p.lpstrDefExt  := PCHar(DefExt); // 'txt' no .  !

p.lCustData          := 0;
p.lpfnHook           := nil;
p.lpTemplateName     := nil;
                     p.lStructSize := SizeOf(p);

if SaveTrue then result := GetSaveFileName(p) else result := GetOpenFileName(p);

  FileName := String(ta);
end;


end.
