unit mymnwin;

interface

uses
    Windows,
    Messages,
    MyConst,
    Algor,
    MyUtils,
    MyDlgAl,
    dbg,
    MyEE,
    spkpl,
    cdialogs,
    mystring,
    SysUtils,
    MyForms;

 const
      main_w : integer = 280;
      main_h : integer = 18;

type
    MyMain = class(TLiteWindow)
    region : THandle;
    protected
           procedure HitTest(Var Msg: TWMNCHitMessage); message  WM_NCHITTEST;
           procedure NcRMouseDown(Var Msg: TMessage); message    WM_NCRBUTTONUP;
           procedure NcMouseMove(Var Msg: TMessage); message     WM_NCMOUSEMOVE;
           procedure NcLMouseDbl(Var Msg: TMessage); message     WM_NCLBUTTONDBLCLK;
           procedure OnMove(Var Msg: TMessage); message          WM_MOVE;
           procedure aftercreate; override;
           procedure OnClose(Var Msg : TMessage); message        WM_CLOSE;
           procedure Close;
           procedure OnQEnd(Var Msg : TMessage); message         WM_QUERYENDSESSION;
           procedure OnEnd(Var Msg : TMessage); message          WM_ENDSESSION;
           procedure OnEUREKA(Var Msg : TMessage); message       WM_EUREKA;
           procedure OnPlayWave(Var Msg : TMessage); message     WM_PLAYWAVE;
           procedure OnInitEXITWINDOWS(Var Msg : TMessage); message WM_INITEXITWINDOWS;
           procedure OnSHS(Var Msg : TMessage); message          WM_SHOWSETUP;
           procedure OnPaint(Var Msg: TMessage); message         WM_PAINT;
           procedure OnCommand(Var Msg: TWMCommand); message     WM_COMMAND;
           procedure OnSysCommand(Var Msg: TWMSysCommand); message  WM_SYSCOMMAND;
           procedure OnHotKey(Var Msg: TWMHotKey); message       WM_HOTKEY;
           procedure OnPosCh(Var Msg : TMessage); message        WM_WINDOWPOSCHANGING;
    private
           procedure full; override;
    public
           procedure SetRegion;    
    end;

var
    main  : MyMain;

function ClockFmt(fmt : string) : string;

function LoadFmtStr : boolean;
function SaveFmtStr(s : string) : boolean;    

implementation

uses application, {hin,} usetup, actions;

procedure MyMain.full;
{CreateWindow}
begin
    efMn := true;
inherited;
self.Fleft    := app.stun.main_left; self.Ftop     := app.stun.main_top;
self.FWidth   := app.stun.siz_clock; self.FHeight  := main_h;
self.Caption  := '';
self.FStyle   := 0;
self.FExStyle := (WS_EX_TOPMOST or WS_EX_TOOLWINDOW or WS_EX_ACCEPTFILES);
self.WindowClassEx.hbrBackground := 0;
self.WindowClassEx.hInstance := app.hinstance;
region := 0;
end;      {CreateWindowEx}

procedure MyMain.aftercreate;
begin
 SetWindowLong(hwnd, GWL_STYLE, GetWindowLong(hwnd, GWL_STYLE) and
                   (Not (WS_CAPTION or WS_BORDER)) );


// region := CreateRoundRectRgn(0,0, main_w, main_h - 1, 22, 22);
// SetWindowRgn(hwnd, region, True);
SetRegion;

 ShowWindow(hwnd, SW_SHOWNORMAL);
////////...........................................
LoadFmtStr;
end;

procedure MyMain.HitTest;
{WM_NCHITTEST}{WM_TOOLTIP}
begin
//     if not app.stun.Fixation then
      msg.result := DefWindowProc(hwnd, msg.msg, TMessage(msg).wparam, TMessage(msg).lparam);//HTCAPTION;
     if msg.Result = HTCLIENT then msg.Result := HTCAPTION;
end;

procedure MyMain.OnMove;
{WM_MOVE}
begin
 MemPosChange;
end;

procedure MyMain.OnClose; {WM_CLOSE} begin app.terminated := true; close; msg.Result := 0; end;
procedure MyMain.Close; begin efMn := false; Destroy; end;

procedure MyMain.NcRMouseDown;  var     a : TPoint;
begin GetCursorPos(a); TrackPopupMenu(app.hfirstmenu, TPM_CENTERALIGN, a.x, a.y, 0, hwnd, nil); end;

procedure MyMain.NcMouseMove;
begin {App.ShowHintWindow} end;

procedure MyMain.NcLMouseDbl; {*1}
begin
// msg.Result := DefWindowProc(hwnd, msg.msg, TMessage(msg).WParam, TMessage(msg).LParam);
 StopSnd;
 app.org.Add;
end;

procedure MyMain.OnEUREKA;
begin
   app.org.ShowMsg;
end;

procedure MyMain.OnPlayWave(Var Msg : TMessage);
begin
    PlaySound(PCHar(msg.LParam), 0,  msg.WParam);
end;

procedure MyMain.OnPaint;
  var
    p         : TPaintStruct;
    s         : string;
    BkColor   : Dword;
    {WDC       : THandle;}
    r         : TRect;
    BColor    : THandle;
 {WM_PAINT}
begin
 DC := GetWindowDC(hwnd); {WDC := }BeginPaint(hwnd, p);

 if app.tun.mute or app.tun.NoAct then BkColor := colr_rd else BkColor := colr_db;
  if app.tun.mute or app.tun.NoAct then BColor := hb_rd else BColor := hb_db;

 r.Left := 0; r.Right := FWidth; r.Top := 0; r.Bottom := FHeight;

 FillRect(DC, r, BColor);

 SelectObject(DC, hf_clock);

 if app.orgtodaycount > 0 then
    SetTextColor(DC, colr_white) else
    SetTextColor(DC, colr_yl);
 SetBkColor(dc, BkColor);
 SetTextAlign(dc, TA_CENTER);

      EndPaint(hwnd, p);

// s := GetLocalHour(app.tun.engtrue_hour_fmt, app.stat.hour); s := s + '.' + inttofix2str(app.stat.minute);

s := ClockFmt(app.fmt_clock);
 TextOut(DC, FWidth div 2 - 1, 0, PCHar(s), Length(s));

 ReleaseDC(hwnd, DC);
 DefWindowProc(hwnd, msg.msg, msg.WParam, msg.LParam);
msg.Result := 0;
end;

procedure MyMain.OnCommand;
  var
    sc : TWMSysCommand;
begin
if msg.Ctl = 0 then begin
 case msg.ItemID of
    100 : app.tun.mute := not app.tun.mute;
    101 : app.tun.NoAct := not app.tun.NoAct;
    102 : app.org.Add;
    103 : app.org.ShowEE(101);
    104 : app.org.ShowEE(100);
    105 : app.ShowFlash;
    106 : app.ShowBook(0);
    107 : begin
    sc.Msg := WM_SYSCOMMAND;
    sc.CmdType := SC_CLOSE;
    sc.YPos := 0;
    PostMessage(hwnd, WM_SYSCOMMAND, TMessage(sc).WParam, TMessage(sc).LParam);
    end;
    108 : app.ShowSetup;
    109 : app.stun.Fixation := not app.stun.Fixation;
    110 : app.ShowBook(1);
    111 : app.ShowBook(2);

 end; {end select}
end; {end if}
end;

procedure MyMain.OnSysCommand(Var Msg: TWMSysCommand);
{WM_SYSCOMMAND}
begin
if msg.CmdType = SC_CLOSE then begin
if MessageBox(hwnd, PCHar(app_quit), PCHar(app_name), bit6 or bit3) <> ID_YES then begin msg.Result := 0; exit; end;
end; {end if}
msg.Result := DefWindowProc(hwnd, msg.msg, TMessage(msg).WParam, TMessage(msg).LParam);
end;

procedure MyMain.OnInitEXITWINDOWS;
begin
 if msg.WParam = 1 then app.ShowExitWindows(true);
 if msg.WParam = 0 then app.ShowExitWindows(false);
 if msg.WParam = 2 then app.Free;
end;
procedure MyMain.OnQEnd(Var Msg : TMessage);
begin
 app.terminated := true;
 msg.Result := Longint(true);
end;
procedure MyMain.OnEnd(Var Msg : TMessage);
begin
 while app.terminated do sleep(0);
 msg.Result := 0;
end;

procedure MyMain.OnHotKey;
begin
case msg.HotKey of
0:   app.org.Add;
1:   app.tun.Mute := not app.tun.Mute;
2:   app.tun.NoAct := not app.tun.NoAct;
3:   app.org.ShowEE(100);
4:   app.org.ShowEE(101);
5:   app.ShowFlash;
6:   app.ShowBook(0);
7:   app.ShowBook(1);
8:   app.ShowBook(2);
9:   app.ShowSetup;

end; {end select}
end;

procedure MyMain.OnPosCh(Var Msg : TMessage);
begin
 if app.stun.Fixation then
 PWindowPos(msg.LParam).flags := PWindowPos(msg.LParam).flags or SWP_NOMOVE;
end;

procedure MyMain.OnSHS(Var Msg : TMessage);
begin
 app.ShowSetup;
end;

function   GetIHour(h : longint) : string;
begin
if app.tun.engtrue_hour_fmt then begin
  if h > 11 then begin
            if h = 12 then result := '12'
            else result := inttostr(h - 12);
  end else       begin
            if h = 0 then result := '12'
            else result := inttostr(h);
                 end; {end if}
end else result := inttostr(h);
end;

function GetFixRtStr(s : string; l : Longint) : string;
  var    f : Longint;
begin result := '';
if s = '' then exit;
for f := 1 to Length(s) do begin if f > l then break; result := result + s[f]; end; {next f}
end;

function ClockFmt(fmt : string) : string;
  var
       l, f : longint;
begin result := '';
l := Length(fmt);
if l = 0 then exit;

f := 0;

while f <> l do begin inc(f);

if fmt[f] = '%' then begin
if 2 > (l - f) then exit;
if (fmt[f + 2] < '0') or (fmt[f + 2] > '9') then exit;

case fmt[f + 1] of
     'a' : result := result + am_hour_pm[app.stat.hour > 12];
     'h' : begin
         result := result + GetIHour(app.stat.hour);     
         case fmt[f + 2] of
         '2' : if Length(result) = 1 then result := '0' + result;
         end; {end select}
         end;
     'm' : case fmt[f + 2] of
         '0' : result := result + inttostr(app.stat.minute);
         '2' : result := result + inttofix2str(app.stat.minute);
         end;
     'd' : case fmt[f + 2] of
         '0' : result := result + inttostr(app.stat.day);
         '2' : result := result + inttofix2str(app.stat.day);
         end;
     'w' : case fmt[f + 2] of
         '0' : result := result + wdn[app.stat.weekday];
         '1'..'9' :  result := result + GetFixRtStr(wdn[app.stat.weekday], strtoint(fmt[f + 2]));
         end;
     'n' : case fmt[f + 2] of
         '0' : result := result + inttostr(app.stat.month);
         '2' : result := result + inttofix2str(app.stat.month);
         end;
     'N' : case fmt[f + 2] of
         '0' : result := result + mon_name[app.stat.month];
         '1'..'9' :  result := result + GetFixRtStr(mon_name[app.stat.month], strtoint(fmt[f + 2]));
         end;
     'y' : begin
         case fmt[f + 2] of
         '1' : result := result + inttostr(app.stat.year mod 10);
         '2' : if (app.stat.year mod 100) > 9 then result := result + inttostr(app.stat.year mod 100) else result := result + '0' + inttostr(app.stat.year mod 100);
         '4' : result := result + inttostr(app.stat.year);
         end;
         end;
     'c' : case fmt[f + 2] of
         '0' : result := result + inttostr(app.orgtodaycount);
         end;
else
     continue;
end; {end select}
inc(f, 2);
end else result := result + fmt[f]; {end if fmt[f] = '%'}

end; {wend}

end;

function LoadFmtStr : boolean;
label eexx;
  var
       fp : Text;
       fn : String;
       fm : Longint;
       s  : String;
begin result := true;
fn := u_dir + fmtc_fn;
AssignFile(fp, fn);
fm := FileMode;
FileMode := 0;
{$I-}
ReSet(fp);
{$I+} if IOResult <> 0 then goto eexx;
{$I-}
ReadLn(fp, s);
{$I+} if IOResult <> 0 then goto eexx;
{$I-}
CloseFile(fp);
{$I+} if IOResult <> 0 then goto eexx;
result := false;
eexx:
FileMode := fm;
if result then app.fmt_clock := pan_fmt else app.fmt_clock := s;
end;

function SaveFmtStr(s : string) : boolean;
label eexx;
  var
       fp : Text;
       fn : String;
       fm : Longint;
begin result := true;
fn := u_dir + fmtc_fn;
SetFileAttributes(PCHar(fn), FILE_ATTRIBUTE_NORMAL);
AssignFile(fp, fn);
fm := FileMode;
FileMode := 1;
{$I-}
ReWrite(fp);
{$I+} if app.FilErr(IOResult, '[ReWrite Fmt File]', false) then goto eexx;
{$I-}
Write(fp, s);
{$I+} if app.FilErr(IOResult, '[Write Fmt File]', false) then goto eexx;
{$I-}
CloseFile(fp);
{$I+} if app.FilErr(IOResult, '[Close Fmt File]', false) then goto eexx;
result := false;
eexx:
FileMode := fm;
end;

procedure MyMain.SetRegion;
begin
 if region <> 0 then begin DeleteObject(region); region := 0; end; {end if}
 FWidth := app.stun.siz_clock;
 FHeight := main_h;
 region := CreateRoundRectRgn(0,0, FWidth, FHeight - 1, 22, 22);
 SetWindowRgn(hwnd, region, True);
 SetWindowPos(hwnd, hwnd, 0, 0, FWidth, FHeight,
 SWP_NOMOVE or SWP_NOZORDER or SWP_FRAMECHANGED or SWP_DRAWFRAME or SWP_NOACTIVATE);
end;

end.
