unit hin;

interface

          uses windows, messages, MyForms, mythread, MyFButt, myutils, dbg, myconst, application, actions, algor;

         const
               hinwin_w = 220; hinwin_o = 10;
type

    THTrd  = class(TThread)
    term : boolean;
    protected
         function    ThreadProcedure: DWord; override;
    end;

type
      MyHintWindow = class(TLiteWindow)
      region : THandle;
      st     : string;

      protected
                 procedure OnClose(Var Msg : TMessage); message       WM_CLOSE;
                 procedure OnPaint(Var Msg: TMessage);  message       WM_PAINT;
      private

      public
           constructor    Create;
           procedure      full; override;
           procedure      aftercreate; override;
           procedure      Close;
      end;

  var
    HintWindow : MyHintWindow;
    HTrd       : THTrd;      

implementation

 uses MyMnWin;

constructor MyHintWindow.Create;
begin
   inherited Create(app.hwnd);
   efHw := true;
   st := '';
end;

procedure MyHintWindow.full;
{CreateWindow}
begin inherited;
self.FHeight := main_h; self.FWidth := hinwin_w; self.Ftop  := main.Ftop;

if main.Fleft > app.sc_w div 2 then begin
self.Fleft := main.Fleft - hinwin_o - hinwin_w;
end else begin
self.Fleft := main.Fleft + hinwin_o + main_w;
end; {end if}

self.Caption := ''; self.FStyle  := 0; self.FExStyle := 0;//(WS_EX_TOPMOST or WS_EX_TOOLWINDOW);
self.WindowClassEx.hbrBackground := CreateSolidBrush(colr_yl){0}; self.WindowClassEx.hInstance := app.hinstance;
end;      {CreateWindowEx}

procedure MyHintWindow.aftercreate;
begin
 SetWindowLong(hwnd, GWL_STYLE, GetWindowLong(hwnd, GWL_STYLE) and
                   (Not (WS_CAPTION or WS_BORDER)) );

 region := CreateRectRgn{CreateRoundRectRgn}(0,0, hinwin_w, main_h - 1{, 22, 22});
 SetWindowRgn(hwnd, region, True);
 ShowWindow(hwnd, SW_SHOWNOACTIVATE{RMAL});

 htrd := THTrd.Create;
 ResumeThread(htrd.ThrHandle);
end;

procedure MyHintWindow.OnClose; begin close; end;
procedure MyHintWindow.Close; begin efHw := false; htrd.term := true; destroy; end;

function THTrd.ThreadProcedure;
  var
    p : TPoint;
    cnt, l, f : Longint;
    c   : Char;
begin cnt := 100;
while (efHw) and (not term) do begin
 GetCursorPos(p);
 if WindowFromPoint(p) <> app.hwnd then break;
 if cnt = 100 then begin
{  HintWindow.st := inttostr(app.stat.year) + ' ' +
   ' / ' + inttofix2str(app.stat.month) + ' (' +
   mon_name[app.stat.month] + ') / ' +
    inttofix2str(app.stat.day) +
     ' (' + wdn[app.stat.weekday] + ') ' +
     str_events + inttostr(app.orgtodaycount) +
      '  .  .  .  ';}

  HintWindow.st := inttostr(app.stat.year) +
   '/' + inttofix2str(app.stat.month) + '(' +
   mon_name[app.stat.month] + ')/' +
    inttofix2str(app.stat.day) +
     '(' + wdn[app.stat.weekday] + ') ' +
     str_events + inttostr(app.orgtodaycount) +
      ' . . . ';

  cnt := 0;
 end; {end if}
// if (cnt mod 1) = 0 then begin
  l := Length(HintWindow.st);
  c := HintWindow.st[1];
  for f := 2 to l do HintWindow.st[f - 1] := HintWindow.st[f];
   HintWindow.st[l] := c;
   PostMessage(hhw, WM_PAINT, 0, 0);
// end; {end if}
    inc(cnt);
 Sleep(200);      //...................
end; {wend}
if efHw then SendMessage(hHw, WM_CLOSE, 0, 0);
ExitThread(0);
self.Destroy;
end;

procedure MyHintWindow.OnPaint;
  var
    p         : TPaintStruct;
    WDC       : THandle;
    r         : TRect;
 {WM_PAINT}
begin
 DC := GetWindowDC(hwnd); WDC := BeginPaint(hwnd, p);

 r.Left := 0; r.Right := hinwin_w; r.Top := 0; r.Bottom := main_h;

 SetTextColor(DC, colr_db);
 SetBkColor(dc, colr_yl);
 SelectObject(dc, hf_clock);
// SetTextAlign(dc, TA_CENTER);

      EndPaint(hwnd, p);

 TextOut(DC, 0{FWidth div 2} , 0, PCHar(st), Length(st));

 ReleaseDC(hwnd, DC);
 DefWindowProc(hwnd, msg.msg, msg.WParam, msg.LParam);
msg.Result := 0;
end;

end.
