unit dlgpeopl;

interface

          uses windows, messages, myforms, myutils, application, mycc,
               commctrl, finddnd, myfbutt, MyDlgAl, myconst, balgor, algor, dbg;

           const dlgp_w = 617; dlgp_h = 378;

type
     MyPeopleDlg = class(TLiteWindow)
     objnew      : boolean;
     chng        : boolean;
     numb        : longint;
     pr          : TPeopleRecord;

     ListView    : TListView;
     IListView   : TListView;
     hCb         : THandle;

     ftab        : word;

     OldCbView   : byte;

     qo,qc,qh,qt : MyQuad;

     protected
         procedure   OnClose(Var Msg : TMessage); message      WM_CLOSE;
         procedure   OnNotify(Var Msg : TWMNotify); message    WM_NOTIFY;
         procedure   OnCommand(Var Msg : TWMCommand); message  WM_COMMAND;
         procedure   WindowProcedure(var Msg : TMessage); override;
         procedure   OnLbu(Var Msg : TMessage); message        WM_LBUTTONUP;
     private
         function    chpok(left, top : integer) : boolean;
     public
         constructor Create(a : longint; newp : boolean);
         procedure   full; override;
         procedure   aftercreate; override;
         procedure   Close;
         procedure   Ld;
         procedure   LdCb(i : longint);
         procedure   SetTab(a : word);
         property    Tab : word read ftab write SetTab;
         procedure   Dr;
         procedure   Ok;
         procedure   Cls;
     end;

  var
    PeopleDlg : MyPeopleDlg;

implementation uses noteb;

constructor MyPeopleDlg.Create(a : longint; newp : boolean);
begin
efDlgPeople := true;
numb := a;
objnew := newp;
chng := false;
pr.reset; pr.ex := true;
if not objnew then pr := NoteBook.book.pnb[numb];
inherited Create(hDesktopWindow);
end;

procedure  MyPeopleDlg.full;
  var
    capsiz : integer;
begin inherited;
capsiz := GetSystemMetrics(SM_CYCAPTION);
FWidth  := dlgp_w; FHeight := dlgp_h + capsiz;
Ftop    := app.sc_h div 2 - FHeight div 2;
Fleft   := app.sc_w div 2 - FWidth  div 2;

Caption := dlgp_caption;
FStyle   := WS_SYSMENU or WS_MINIMIZEBOX or WS_VISIBLE;
FExStyle := 0; WindowClassEx.hInstance := app.hinstance;
WindowClassEx.hbrBackground := CreateSolidBrush(colr_my);
WindowClassEx.hIcon := app.hi_face;
end;

procedure  MyPeopleDlg.aftercreate;
  var
    f  : longint;
    p  : TLVItem;
begin

  EBmpCreate(hwnd, app.hinstance, 'OKBTN', 522, 340, false);
  EBmpCreate(hwnd, app.hinstance, 'CNBTN', 522, 310, false);
  EBmpCreate(hwnd, app.hinstance, 'PIROG', 535, 200, false);
  EBmpCreate(hwnd, app.hinstance, 'HLBTN', 522, 38, false);

qo.r.left := 522; qo.r.top := 340; qo.r.width := 81; qo.r.height := 20;
qc.r.left := 522; qc.r.top := 310; qc.r.width := 81; qc.r.height := 20;
qh.r.left := 522; qh.r.top := 38; qh.r.width := 81; qh.r.height := 20;
qt.r.left := 534; qt.r.top := 200; qt.r.width := 57; qt.r.height := 60;

ListView := TListView.Create;
ListView.Crt(hwnd, app.hinstance, 4, 34, 510, 330{300},
LVS_NOCOLUMNHEADER or LVS_SINGLESEL or LVS_SHAREIMAGELISTS or LVS_REPORT or WS_VISIBLE or LVS_AUTOARRANGE or LVS_SHOWSELALWAYS or WS_CHILD,
WS_EX_OVERLAPPEDWINDOW, 0, nil);

ListView.InsertColumn(0, 0, 200, '');
ListView.InsertColumn(1, 1, 580, '');

ListView_SetExtendedListViewStyle(ListView.hwnd, LVS_EX_GRIDLINES or LVS_EX_FULLROWSELECT);

hcb := ComboBox.Create(hwnd, app.hinstance, '', 4, 4, 600, 330, false, false, false, false, false, false, book_max_mems_len);
ComboBox.Enable[hcb] := false;

IListView := TListView.Create;
IListView.Crt(hwnd, app.hinstance, 531 {525}, 80, 60{70}, 64{70},
LVS_SHOWSELALWAYS or LVS_SINGLESEL or LVS_ALIGNLEFT or LVS_SHAREIMAGELISTS or LVS_ICON or WS_VISIBLE or LVS_AUTOARRANGE or LVS_SHOWSELALWAYS or WS_CHILD,
WS_EX_OVERLAPPEDWINDOW, 0, nil);

for f := 0 to notebook.ListViewIl.Count do begin
p.mask       := LVIF_IMAGE;
p.iItem      := f;
p.iSubItem   := 0;
p.state      := 0;
p.stateMask  := 0;
p.pszText    := '';
p.cchTextMax := 0;
p.iImage     := f;
p.lParam     := 0;
SendMessage(IListView.hwnd, LVM_INSERTITEM, 0, Longint(@p));
end; {next f}
IListView.AssociateImageList(notebook.ListViewIl.fhwnd, true);

ld;
OldCbView := 255;
SetTab(0);
IListView.SetFocusedItem(pr.ii, true);
end;

procedure  MyPeopleDlg.OnClose; begin
  if objnew then NoteBook.book.pnb[numb].ex := false;
 close; end;
procedure  MyPeopleDlg.Close; begin   efDlgPeople := false; destroy; end;

procedure  MyPeopleDlg.Ld;
  var
    f : longint;
    p : TLVItem;
begin
for f := 0 to max_peop_mem do begin
p.mask          := LVIF_TEXT;
p.iItem         := f;
p.iSubItem      := 0;
p.state         := 0;
p.stateMask     := 0;
p.pszText       := LPSTR_TEXTCALLBACK;
p.cchTextMax    := 0;
p.iImage        := 0;
p.lParam        := 0;
 SendMessage(ListView.hwnd, LVM_INSERTITEM, 0, Longint(@p));
p.iSubItem      := 1;
 SendMessage(ListView.hwnd, LVM_INSERTITEM, 0, Longint(@p));
end; {next f}
end;


procedure MyPeopleDlg.WindowProcedure(var Msg : TMessage);
  var d : TDecodeKey; ctrl, shift : boolean;
      tmp   : longint; l : TLVItem;
begin
case msg.Msg of
     WM_KEYDOWN: begin
      d := DecodeKey(msg.WParam, msg.LParam);
       ctrl := GetAsyncKeyState(VK_CONTROL) = -32768;
       shift   := GetAsyncKeyState(VK_SHIFT)   = -32768;
  //    msg.result := 1;
      case d.virt of
       VK_RETURN : msg.result := 1;
       VK_ESCAPE : begin cls; msg.Result := 1; end;
       9         : msg.result := 1;
    //   VK_DELETE : delete;
      else
          msg.result := 0;
      end; {end select}

     end;
//     WM_ACTIVATE :  tab := tab;
     WM_KEYUP: begin
      d := DecodeKey(msg.WParam, msg.LParam);
       ctrl := GetAsyncKeyState(VK_CONTROL) = -32768;
       shift   := GetAsyncKeyState(VK_SHIFT)   = -32768;
//      msg.Result := 1;
      case d.virt of
           9    : begin
           if 2 > tab then tab := tab + 1 else tab := 0;
           msg.Result := 1;
           end;
           VK_RETURN : ok;
           VK_F1     : app.ShowHelp(5);
           VK_F2     : dr;
      else
          msg.result := 0;
      end; {end select d.virt}
     end; {ku}
else
    Dispatch(msg);
end; {end select msg.msg}
end;


procedure   MyPeopleDlg.LdCb(i : longint);
  var
    f, tmp : longint;
begin tmp  := 255;
case i of
const_book_p_fam1, const_book_p_fam2 : tmp := 0;
const_book_p_gr1 ,  const_book_p_gr2 : tmp := 1;
const_book_p_sex                     : tmp := 2;
end; {end select}
if tmp = OldCbView then exit;

ComboBox.Clear(hcb);

case i of
const_book_p_fam1, const_book_p_fam2 : begin
for f := 0 to MAX_BOOK * 2 do if notebook.Fams[f] <> '' then ComboBox.Add(hcb, notebook.fams[f]);
OldCbView := 0;
end;
const_book_p_gr1, const_book_p_gr2   : begin
for f := 0 to MAX_BOOK * 2 do if notebook.pgr[f] <> '' then ComboBox.Add(hcb, notebook.pgr[f]);
OldCbView := 1;
end;
const_book_p_sex                     : begin
for f := 0 to MAX_BOOK     do if notebook.psx[f] <> '' then ComboBox.Add(hcb, notebook.psx[f]);
OldCbView := 2;
end;
 else
  OldCbView := 254;
end; {end select}
end;

procedure MyPeopleDlg.OnNotify;  {WM_NOTIFY}
begin
 msg.Result := DefWindowProc(hwnd, msg.msg, TMessage(msg).WParam, TMessage(msg).LParam);

if msg.NMHdr.hwndFrom = ListView.hwnd then begin
   case msg.NMHdr.code of
//   NM_SETFOCUS : ftab := false;
   LVN_GETDISPINFO : begin
                   if PLvDispInfo(msg.NMHdr).item.iSubItem = 0 then begin
                   PLvDispInfo(msg.NMHdr).item.mask := LVIF_TEXT or LVIF_DI_SETITEM;
                   PLvDispInfo(msg.NMHdr).item.pszText := PCHar(book_people_mem_names[PLvDispInfo(msg.NMHdr).item.iItem]);
                   end else begin
                   PLvDispInfo(msg.NMHdr).item.mask := LVIF_TEXT;
                   PLvDispInfo(msg.NMHdr).item.pszText := PCHar(pr.a[PLvDispInfo(msg.NMHdr).item.iItem]);
                   end; {end if}
   end;
   LVN_ITEMCHANGING : begin
                   if PNMListView(msg.NMHdr).isubitem = 0 then begin
                   LdCb(PNMListView(msg.NMHdr).iitem);
                   ComboBox.Text[hcb] := pr.a[PNMListView(msg.NMHdr).iitem];
                   if not ComboBox.Enable[hcb] then ComboBox.Enable[hcb] := true;
                   end; {end if}
   end;
   NM_DBLCLK       : SetFocus(hcb);
   end; {end select}
end; {end if}
if msg.NMHdr.hwndFrom = IListView.hwnd then begin
   case msg.NMHdr.code of
   LVN_ITEMCHANGING : begin
                   pr.ii := PNMListView(msg.NMHdr).iitem;
                   msg.Result := Longint(false);
   end;
   end; {end select}
end; {end if}
end;

procedure MyPeopleDlg.OnCommand;
  var
    f : longint;
begin
if msg.Ctl = hcb then begin
case msg.NotifyCode of
 CBN_EDITCHANGE : begin
 f := ListView.GetFocusedItemIndex;
 pr.a[f] := ComboBox.Text[hcb];
 SendMessage(ListView.hwnd, LVM_UPDATE, f, 0);
 chng := true;
 end;
 CBN_SELENDOK   : begin
 f := ListView.GetFocusedItemIndex;
 pr.a[f] := ComboBox.GetItemText(hcb, ComboBox.Select[hcb]);
 SendMessage(ListView.hwnd, LVM_UPDATE, f, 0);
 chng := true;
 end;
end; {end select}
end; {end if}
end;

procedure   MyPeopleDlg.SetTab(a : word);
  var
    tmp : THandle;
begin
ftab := a;
case a of
0 : tmp := ListView.hwnd;
1 : tmp := hcb;
2 : tmp := IListView.hwnd;
end; {end select}
SetFocus(tmp);
end;

procedure MyPeopleDlg.Ok;
begin
if pr.ii <> NoteBook.book.pnb[numb].ii then
 chng := true;

if chng then begin
ShowWindow(hwnd, SW_HIDE);
ShowWindow(NoteBook.Hwnd, SW_HIDE);
NoteBook.book.pnb[numb] := pr;
NoteBook.BookFileP(true);
end; {end if}
  NoteBook.SetView(0, '', true);
  Close;
end;
procedure MyPeopleDlg.Cls;
begin
  if objnew then NoteBook.book.pnb[numb].ex := false;
  Close;
end;

procedure MyPeopleDlg.OnLbu;
begin     chpok(LOWORD(msg.lparam),HIWORD(msg.lparam));
     msg.Result := DefWindowProc(hwnd, msg.msg, msg.WParam, msg.LParam); end;

function MyPeopleDlg.chpok(left, top : integer) : boolean;
 procedure vc(a : MyQuad); var dc, hreg : THandle; r : TRect;
 begin  dc := GetDC(hwnd);
  r := MyRectToTRect(a.r);
  hreg :=  CreateRoundRectRgn(r.Left, r.top, r.Right, r.Bottom, 15, 15);
  SelectObject(dc, hreg);
   InvertRgn(dc, hreg);
     Sleep(110);
   InvertRgn(dc, hreg);
  DeleteObject(hreg);
  ReleaseDC(hwnd, dc);
 end;
begin result := ((qo.r.left <= left) and (qo.r.left + qo.r.width >= left)) and
((qo.r.top <= top) and (qo.r.height + qo.r.top >= top));

if result then begin
 vc(qo);
 ok;
 exit;
end; {end if}

result := ((qc.r.left <= left) and (qc.r.left + qc.r.width >= left)) and
((qc.r.top <= top) and (qc.r.height + qc.r.top >= top));

if result then begin
 vc(qc);
 cls;
 exit;
end; {end if}

result := ((qh.r.left <= left) and (qh.r.left + qh.r.width >= left)) and
((qh.r.top <= top) and (qh.r.height + qh.r.top >= top));

if result then begin
 vc(qh);
         app.ShowHelp(5);
 exit;
end; {end if}

result := ((qt.r.left <= left) and (qt.r.left + qt.r.width >= left)) and
((qt.r.top <= top) and (qt.r.height + qt.r.top >= top));

if result then begin
 vc(qt);
 dr;
 exit;
end; {end if}
end;

procedure   MyPeopleDlg.Dr;
label eerr;
  var
    s, tmp          : string;
    f, mon, dt, yr  : longint;
begin
s := pr.a[const_book_drj];
if length(s) < 10 then goto eerr;

obj.Reset;

tmp := copy(s, 1, 4); yr := strtointdef(tmp, $FFFFFFFF);
tmp := copy(s, 6, 2); mon := strtointdef(tmp, $FFFFFFFF);
tmp := copy(s, 9, 2); dt := strtointdef(tmp, $FFFFFFFF);

if obj.TryPutData(yr, mon, dt) then goto eerr;

   obj.period  := 8;
   obj.remove  := false;
   obj.display := true;

if String(pr.a[0]) <> '' then begin
 s := pr.a[0];
end else begin
 s := pr.a[1] + ' ' + pr.a[2];
end; {end if}
 s := dlgp_str_brd + s;
obj.mess := s;

if efAld then begin
 if isIconic(hAlarmDialog) then ShowWindow(hAlarmDialog, SW_SHOWNORMAL);
 BringWindowToTop(hAlarmDialog); SetForegroundWindow(hAlarmDialog); exit; end;
AlarmDlg := MyAlarmDlg.Create($FFFFFFFF); hAlarmDialog := AlarmDlg.hwnd;
BringWindowToTop(hAlarmDialog);
SetForegroundWindow(hAlarmDialog);

exit;
eerr:
  MessageBox(hwnd, PCHar(dlgp_err_dr_export), PCHar(app_name), bit5);
end;

end.
