unit spkpl;

interface
          uses windows, mythread;

type
     MyN = record
     tone : word;
     delay : word;
     len : word;
     end; {end MyN}
     TGetMusicName = function (n : byte) : PChar; stdcall;
     TGetName = function : PChar; stdcall;
     TGetMusic = function (n : byte; pos : word) : MyN; stdcall;

type
     MySpeakerPlay = class(TThread)
     public
     function    ThreadProcedure: DWord; override;
     end;

procedure spk(b : word); procedure spkon; procedure spkoff;

  var
    slFileName   : string;
    meln         : byte;
    wnt          : boolean;
    SpeakerPlay  : MySpeakerPlay;
    ProcessMusic : boolean;
    stop         : boolean;

procedure PlayMusic(FileName : string; mel : byte; synchro, nt : boolean);

procedure SpeakerBeepSync(tone : word; delay : dword; nt : boolean);

implementation

  var
       process_spk_bp : boolean;

procedure PM;
  var
    f, l : word;
    tm : word;
    GetMusic : TGetMusic;
    h : THandle;
begin
processmusic := true;

h := LoadLibrary(PCHar(slFileName));
 @GetMusic := GetProcAddress(h, 'GetMusic');
 if @GetMusic = nil then begin processmusic := false; exit; end;

l := getmusic(meln, 1).len;

if wnt then begin //////
for f := 1 to l do begin
if stop then break;
 if getmusic(meln, f).tone > 1 then begin
  tm := getmusic(meln, f).tone;
  windows.Beep(tm, getmusic(meln, f).delay);
 end else sleep(getmusic(meln, f).delay); {end if}
end; {next f}
end else begin ////////
spk(1);
for f := 1 to l do begin
if stop then break;
spkon;
 tm := getmusic(meln, f).tone;
 if tm > 1 then begin
  tm := 1193280 div getmusic(meln, f).tone;
spk(tm);
sleep(getmusic(meln, f).delay);
end else begin spkoff; sleep(getmusic(meln, f).delay); end; {end if}
end; {next f}
spkoff;
end; {end if nt} //////
FreeLibrary(h);

processmusic := false;
end;

procedure PlayMusic(FileName : string; mel : byte; synchro, nt : boolean);
begin
if processmusic then exit;
 slFileName := FileName; meln := mel; wnt := nt; stop := false;
 if synchro then pm
 else begin
  processmusic := true;
  SpeakerPlay := MySpeakerPlay.Create;
  ResumeThread(SpeakerPlay.ThrHandle);
 end; {end if}
end;

procedure spkon;
begin
 asm
        push    eax
        in      al, 61h
        or      al, 03h
        out     61h, al
        pop     eax
 end;
end;
procedure spkoff;
begin
 asm
        push    eax
 	in      al, 61h
        or      al, 03h
        xor     al, 03h
        out     61h, al
        pop     eax
 end;
end;
procedure spk(b : word );
var hb, lb : byte;
begin; hb := hi (b); lb := lo (b);
 asm
        push    eax
        mov     al, 0B6h
        out     43h, al
        mov     al, lb
        out     42h, al
        mov     al, hb
        out     42h, al
        pop     eax
 end;
end;

function MySpeakerPlay.ThreadProcedure: DWord;
begin SetThreadPriority(ThrHandle, THREAD_PRIORITY_TIME_CRITICAL);
 pm;
 ExitThread(0); self.Destroy;
end;

procedure SpeakerBeepSync(tone : word; delay : dword; nt : boolean);
begin if (process_spk_bp or processmusic) then exit; process_spk_bp := true;
if nt then begin
windows.Beep(tone, delay);
end else begin
spkon;
spk(1193280 div tone);
sleep(delay);
spkoff;
end; {end if}
process_spk_bp := false;
end;

initialization
              processmusic := false;
              process_spk_bp := false;
finalization

end.
